<?php

require_once ROOTPATH.'/modules/calendar/interceptors/Helpers.php';

class LDAPMapping extends Helpers {
	
       //externalUser
	  static $usertMap = array(	'id'   => 'uidnumber',
                                        'name' => 'cn',
                                        'mail' => 'mail',
                                        'mailAlternateAddress' => 'mailalternateaddress');
    
    
    public function decodeReadUser( &$uri , &$result , &$criteria , $original  ){
        $result = self::parseConcept( $result , self::$usertMap , true ); 
    }

   public function encodeFindUser( &$uri , &$params , &$criteria , $original ){
            if(isset($criteria['filter']))
            {
                if($criteria['filter'][0] === '*' && $criteria['filter'][1] === 'name') //Busca pelo nome usar DFD00032
                    $criteria['filter'] = array('AND',
                                                array('AND' , 
                                                            array('=' , 'objectClass' , 'phpgwAccount'),
                                                            array('OR' , 
                                                                        array('=' , 'phpgwAccountType' , 'i'),
                                                                        array('=' , 'phpgwAccountType' , 'u'),
                                                                        array('=' , 'phpgwAccountType' , 's')
                                                                 ) 
                                                    ),
                                                 array('AND' ,  
                                                                array('!','phpgwAccountVisible','-1'),
                                                                array('OR', 
                                                                        array('=','phpgwAccountStatus','A'),
                                                                        array('=','accountStatus','active'),
                                                                        array('=','objectClass','posixGroup')
                                                                    ),
                                                                array('OR', 
                                                                        array('*','cn',$criteria['filter'][2]),
                                                                        array('*','givenName',$criteria['filter'][2]),
                                                                        array('*','uid',$criteria['filter'][2]),
                                                                        array('*','sn',$criteria['filter'][2]),
                                                                        array('*','displayName',$criteria['filter'][2]),
                                                                        array('*','mail',$criteria['filter'][2]),
                                                                        array('*','mailAlternateAddress',$criteria['filter'][2]),
                                                                    )
                                                          )
                                                );
                else
                    $criteria['filter'] = self::parseFilter($criteria['filter'], self::$usertMap);
            }
          
    }  
    
       /*
		  * ex: array   ( 
		  *		  [0] 'OR',
		  *		  [1] array( 'OR', array( array( '=', 'campo', 'valor' ) ), 
		  *		  [2] array( '=', 'campo' , 'valor' ),
		  *		  [3] array( 'IN', 'campo', array( '1' , '2' , '3' ) )
		  *		)
		  * OR
		  *	    array( '=' , 'campo' , 'valor' )
		*/
    
    public function decodeFindUser( &$uri , &$result , &$criteria , $original ){        
        foreach ($result as $i => $v)
            $result[$i] = self::parseConcept( $v , self::$usertMap , true ); 
        
    }  
        
}

?>
